Get Started with ag-Grid in Your Project
ag-Grid is the industry standard for JavaScript Enterprise Applications. Developers using ag-Grid
are building applications that would not be possible if ag-Grid did not exist.
var columnDefs = [
{headerName: "Make", field: "make"},
{headerName: "Model", field: "model"},
{headerName: "Price", field: "price"}
];
// specify the data
var rowData = [
{make: "Toyota", model: "Celica", price: 35000},
{make: "Ford", model: "Mondeo", price: 32000},
{make: "Porsche", model: "Boxter", price: 72000}
];
// let the grid know which columns and what data to use
var gridOptions = {
columnDefs: columnDefs,
rowData: rowData
};
// setup the grid after the page has finished loading
document.addEventListener('DOMContentLoaded', function() {
var gridDiv = document.querySelector('#myGrid');
new agGrid.Grid(gridDiv, gridOptions);
});
<!DOCTYPE html>
<html lang="en">
<head>
<title>Ag-Grid Basic Example</title>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.js"></script>
<script src="main.js"></script>
</head>
<body>
<div id="myGrid" style="height: 200px; width:500px;" class="ag-theme-balham"></div>
</body>
</html>
Getting Started
In this article, we will walk you through the necessary steps to add ag-Grid to an existing JavaScript
project, and configure some of the essential features of it.
We will show you some of the fundamentals of the grid (passing properties, using the API, etc).
The Project Setup
During the last couple of years, we are witnessing a Cambrian Explosion of JavaScript project stacks. It seems like everyday there is a new, better way for JavaScript developers to build and distribute their apps.
However, for the purposes of this setup, we are going to stick to tried-and-true no-build, single HTML file setup which loads the ag-Grid scripts from CDN (our favorite one is unpkg). Let's start from this clean html file:
<!DOCTYPE html>
<html>
<head>
</head>
<body>
<h1>Hello from ag-grid!</h1>
</body>
</html>
Add ag-Grid to Your Project
We are going to load the necessary scripts and styles from the unpkg CDN. Add the following to the head element:
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
</body>
</html>
The lines above import the AgGrid component, the grid "structure" stylesheet (ag-grid.css), and one of the available grid themes: (ag-theme-balham.css).
The grid ships several different themes; pick one that matches your project design.
Now, let's instantiate a grid!
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
<div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div>
<script type="text/javascript" charset="utf-8">
// specify the columns
var columnDefs = [
{headerName: "Make", field: "make"},
{headerName: "Model", field: "model"},
{headerName: "Price", field: "price"}
];
// specify the data
var rowData = [
{make: "Toyota", model: "Celica", price: 35000},
{make: "Ford", model: "Mondeo", price: 32000},
{make: "Porsche", model: "Boxter", price: 72000}
];
// let the grid know which columns and what data to use
var gridOptions = {
columnDefs: columnDefs,
rowData: rowData
};
// lookup the container we want the Grid to use
var eGridDiv = document.querySelector('#myGrid');
// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(eGridDiv, gridOptions);
</script>
</body>
</html>
The variables above present two essential configuration properties of the grid - the column definitions (columnDefs) and the data (rowData). In our case, the column definitions contain three columns;
each column entry specifies the header label and the data field to be displayed in the body of the table.
The actual data is defined in the rowData as an array of objects. Notice that the fields of the objects match the field values in the columnDefs configuration object.
Finally, the DIV element is the DOM entry point of the grid. It sets the grid dimensions and specifies the grid's theme by setting the class to ag-theme-balham. As you may have already noticed, the CSS class matches the name of CSS file we imported earlier.
Enable Sorting And Filtering
So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most expensive?
Well, enabling sorting in ag-Grid is actually quite simple - all you need to do is add sortable to each column.
var columnDefs = [
{headerName: "Make", field: "make", sortable: true },
{headerName: "Model", field: "model", sortable: true },
{headerName: "Price", field: "price", sortable: true }
];
After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.
Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) of rows, with many columns. In a data set like this filtering is your friend.
As with sorting, enabling filtering is as easy as adding the filter property:
var columnDefs = [
{headerName: "Make", field: "make", sortable: true, filter: true },
{headerName: "Model", field: "model", sortable: true, filter: true },
{headerName: "Price", field: "price", sortable: true, filter: true }
];
With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with a filtering UI which lets you choose the kind of filter and the text that you want to filter by.
Fetch Remote Data
Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the time, we are dealing with data that resides on a remote server. Nowadays, implementing this is actually quite simple.
Notice that the actual data fetching is performed outside of the grid component - We are using the HTML5 fetch API.
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
<div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div>
<script type="text/javascript" charset="utf-8">
// specify the columns
var columnDefs = [
{headerName: "Make", field: "make"},
{headerName: "Model", field: "model"},
{headerName: "Price", field: "price"}
];
// let the grid know which columns to use
var gridOptions = {
columnDefs: columnDefs
};
// lookup the container we want the Grid to use
var eGridDiv = document.querySelector('#myGrid');
// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(eGridDiv, gridOptions);
agGrid.simpleHttpRequest({url: 'https://api.myjson.com/bins/ly7d1'}).then(function(data) {
gridOptions.api.setRowData(data);
});
</script>
</body>
</html>
Here, we replaced the rowData assignment with a data fetch from a remote service. The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid.
Notice that we also did something new - we accessed the grid Api instance through the gridOptions.api. The api object exposes plethora of methods that allow us to implement complex scenarios with the grid.
Enable Selection
Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements!
It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system.
We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.
Fortunately, the above task is quite simple with ag-Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties:
// specify the columns
var columnDefs = [
{headerName: "Make", field: "make", checkboxSelection: true },
{headerName: "Model", field: "model"},
{headerName: "Price", field: "price"}
];
// let the grid know which columns and what data to use
var gridOptions = {
columnDefs: columnDefs,
rowSelection: 'multiple'
};
Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:
<button onclick="getSelectedRows()">Get Selected Rows</button>
<div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div>
function getSelectedRows() {
var selectedNodes = gridOptions.api.getSelectedNodes()
var selectedData = selectedNodes.map( function(node) { return node.data })
var selectedDataStringPresentation = selectedData.map( function(node) { return node.make + ' ' + node.model }).join(', ')
alert('Selected nodes: ' + selectedDataStringPresentation);
}
Well, we cheated a bit. Calling alert is not exactly a call to our backend.
Hopefully you will forgive us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit with a real-world application logic after you are done with the tutorial.
What happened above? Several things:
- We added a button with an event handler;
- Inside the event handler, we accessed the grid API to get the currently selected grid row nodes;
- Afterwards, we extracted the row nodes' underlying data items and converted them to a string suitable to be presented to the user in an alert box.
Grouping
Grouping is a feature exclusive to ag-Grid Enterprise. You are free to trial ag-Grid Enterprise to see what you
think. You only need to get in touch if you want to start using ag-Grid Enterprise in a project intended
for production.
In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data. In our case, the data is not that much. Let's switch to a slightly larger data set:
- agGrid.simpleHttpRequest({url: 'https://api.myjson.com/bins/ly7d1'}).then(function(data) {
+ agGrid.simpleHttpRequest({url: 'https://api.myjson.com/bins/15psn9'}).then(function(data) {
Now, let's use ag-grid-enterprise! Replace the ag-grid script reference in the head with this one:
<script src="https://unpkg.com/ag-grid-enterprise/dist/ag-grid-enterprise.min.noStyle.js"></script>
If everything is ok, you should see a message in the console that tells you there is no enterprise license key.
You can ignore the message as we are trialing.
In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup -
feel free to look around:
Now, let's enable grouping! Change the configuration to this:
var columnDefs = [
{headerName: "Make", field: "make", rowGroup: true },
{headerName: "Price", field: "price"}
];
var autoGroupColumnDef = {
headerName: "Model",
field: "model",
cellRenderer:'agGroupCellRenderer',
cellRendererParams: {
checkbox: true
}
}
// let the grid know which columns and what data to use
var gridOptions = {
columnDefs: columnDefs,
autoGroupColumnDef: autoGroupColumnDef,
groupSelectsChildren: true,
rowSelection: 'multiple'
};
There we go! The grid now groups the data by make, while listing the model field value when expanded. Notice that grouping works with checkboxes as well - the groupSelectsChildren property adds a group-level checkbox that selects/deselects all items in the group.
Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.
This is how the final code should look:
<!DOCTYPE html>
<html>
<head>
<script src="https://unpkg.com/ag-grid-enterprise/dist/ag-grid-enterprise.min.noStyle.js"></script>
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css">
<link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css">
</head>
<body>
<h1>Hello from ag-grid!</h1>
<button onclick="getSelectedRows()">Get Selected Rows</button>
<div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div>
<script type="text/javascript" charset="utf-8">
// specify the columns
var columnDefs = [
{headerName: "Make", field: "make", rowGroup: true },
{headerName: "Price", field: "price"}
];
var autoGroupColumnDef = {
headerName: "Model",
field: "model",
cellRenderer:'agGroupCellRenderer',
cellRendererParams: {
checkbox: true
}
}
// let the grid know which columns and what data to use
var gridOptions = {
columnDefs: columnDefs,
autoGroupColumnDef: autoGroupColumnDef,
groupSelectsChildren: true,
rowSelection: 'multiple'
};
// lookup the container we want the Grid to use
var eGridDiv = document.querySelector('#myGrid');
// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(eGridDiv, gridOptions);
agGrid.simpleHttpRequest({url: 'https://api.myjson.com/bins/15psn9'}).then(function(data) {
gridOptions.api.setRowData(data);
});
function getSelectedRows() {
const selectedNodes = gridOptions.api.getSelectedNodes()
const selectedData = selectedNodes.map( function(node) { return node.data })
const selectedDataStringPresentation = selectedData.map( function(node) { return node.make + ' ' + node.model }).join(', ')
alert('Selected nodes: ' + selectedDataStringPresentation);
}
</script>
</body>
</html>
Summary
With this Javascript datagrid tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping!
While doing so, we learned how to configure the grid and how how to use its api object to call methods.
Next Steps
The best thing you can check after the Javascript grid tutorial is the features overview. It provides an extensive review of what you can achieve with ag-Grid. In addition, you can go through the following help articles to learn more about the features we enabled:

Angular Grid | Get Started with ag-Grid and Angular

ag-Grid is the industry standard for Angular Enterprise Applications. Developers using ag-Grid are building applications that would not be possible if ag-Grid did not exist.

Quick Look Code Example
import { Component } from '@angular/core'; @Component({ selector: 'my-app', templateUrl: './app.component.html', styleUrls: [ './app.component.scss' ] }) export class AppComponent { columnDefs = [ {field: 'make' }, {field: 'model' }, {field: 'price'} ]; rowData = [ { make: 'Toyota', model: 'Celica', price: 35000 }, { make: 'Ford', model: 'Mondeo', price: 32000 }, { make: 'Porsche', model: 'Boxter', price: 72000 } ]; }
<ag-grid-angular style="width: 500px; height: 150px;" class="ag-theme-balham" [rowData]="rowData" [columnDefs]="columnDefs"> </ag-grid-angular>
Getting Started Video Tutorial

Getting Started

Below we walk through the necessary steps to add ag-Grid (both Community and Enterprise are covered) to an Angular project and configure some grid features. In particular, we will go through the following steps:

Add ag-Grid to Your Project

For the purposes of this tutorial, we are going to scaffold an Angular app with angular CLI. Don't worry if your project has a different configuration. ag-Grid and its Angular wrapper are distributed as NPM packages, which should work with any common Angular project module bundler setup. Let's follow the Angular CLI instructions - run the following in your terminal:

npm install -g @angular/cli ng new my-app --style scss --routing false cd my-app ng serve npm install -g @angular/cling new my-app --style scss --routing false cd my-app ng serve
We are passing --style scss to the app scaffolding command so that we may customise the grid theme look through Sass variables.

If everything goes well, ng serve has started the web server. You can open your app at localhost:4200.

As a next step, let's add the ag-Grid NPM packages. run the following command in my-app (you may need a new instance of the terminal):

npm install --save ag-grid-community ag-grid-angular npm install # in certain circumstances npm will perform an "auto prune". This step ensures all expected dependencies are present

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! As a first step, let's add the ag-Grid Angular module to our app module (src/app/app.module.ts):

import { BrowserModule } from '@angular/platform-browser'; import { NgModule } from '@angular/core'; import { AppComponent } from './app.component'; import { AgGridModule } from 'ag-grid-angular'; @NgModule({ declarations: [AppComponent], imports: [ BrowserModule, AgGridModule.withComponents([]) ], providers: [], bootstrap: [AppComponent] }) export class AppModule {}
The withComponents call is necessary for the grid to be able to use Angular components as cells / headers - you can ignore it for now.

The next step is to add the ag-Grid styles - replace the content of styles.scss with the following code:

@import "../node_modules/ag-grid-community/src/styles/ag-grid.scss"; @import "../node_modules/ag-grid-community/src/styles/ag-theme-alpine/sass/ag-theme-alpine-mixin.scss"; .ag-theme-alpine { @include ag-theme-alpine(); }

The code above imports the grid "structure" stylesheet (ag-grid.css), and one of the available grid themes: (ag-theme-alpine.css). The grid ships several different themes; pick one that matches your project design. You can customise it further with Sass variables, a technique which we will cover further down the road.

Next, let's declare the basic grid configuration. Edit src/app.component.ts:

import { Component } from '@angular/core'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent { title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make' }, {headerName: 'Model', field: 'model' }, {headerName: 'Price', field: 'price'} ]; rowData = [ { make: 'Toyota', model: 'Celica', price: 35000 }, { make: 'Ford', model: 'Mondeo', price: 32000 }, { make: 'Porsche', model: 'Boxter', price: 72000 } ]; }

The code above presents two essential configuration properties of the grid - the column definitions (columnDefs) and the data (rowData). In our case, the column definitions contain three columns; each column entry specifies the header label and the data field to be displayed in the body of the table.

Finally, let's add the component definition to our template. Edit app/app.component.html and remove the scaffold code:

<ag-grid-angular style="width: 500px; height: 500px;" class="ag-theme-alpine" [rowData]="rowData" [columnDefs]="columnDefs" > </ag-grid-angular>

This is the ag-grid component definition, with two property bindings - rowData and columnDefs. The component also accepts the standard DOM style and class. We have set the class to ag-theme-alpine, which defines the grid theme. As you may have already noticed, the CSS class matches the name of CSS file we imported earlier.

If everything works as expected, you should see a simple grid like the one on the screenshot:

ag-Grid hello world

Enable Sorting And Filtering

So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most expensive? Well, enabling sorting in ag-Grid is actually quite simple - all you need to do is set the sortable property to each column you want to be able to sort by.

columnDefs = [ {headerName: 'Make', field: 'make', sortable: true}, {headerName: 'Model', field: 'model', sortable: true}, {headerName: 'Price', field: 'price', sortable: true} ];

After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.

Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) of rows, with many columns. In a data set like this filtering is your friend.

As with sorting, enabling filtering is as easy as setting the filter property:

columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true}, {headerName: 'Model', field: 'model', sortable: true, filter: true}, {headerName: 'Price', field: 'price', sortable: true, filter: true} ];

With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with a filtering UI which lets you choose the kind of filter and the text that you want to filter by.

ag-Grid sorting and filtering

Fetch Remote Data

Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the time, we are dealing with data that resides on a remote server. Thanks to Angular, implementing this is actually quite simple. Notice that the actual data fetching is performed outside of the grid component - We are using Angular's HttpClient and an async pipe. As a first step, let's add the HttpModule to our app module:

import { BrowserModule } from '@angular/platform-browser'; import { NgModule } from '@angular/core'; import { AppComponent } from './app.component'; import { AgGridModule } from 'ag-grid-angular'; import { HttpClientModule } from '@angular/common/http'; @NgModule({ declarations: [AppComponent], imports: [BrowserModule, HttpClientModule, AgGridModule.withComponents([])], providers: [], bootstrap: [AppComponent] }) export class AppModule {}

Now, let's remove the hard-coded data and fetch it from a remote server. Edit the src/app.component.ts to this:

import { Component, OnInit } from '@angular/core'; import { HttpClient } from '@angular/common/http'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true}, {headerName: 'Model', field: 'model', sortable: true, filter: true}, {headerName: 'Price', field: 'price', sortable: true, filter: true} ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://raw.githubusercontent.com/ag-grid/ag-grid/master/grid-packages/ag-grid-docs/src/sample-data/rowData.json'); } }

The above code turns the rowData from a hard-coded array to an Observable. For the grid to work with it, we need to add an async pipe to the property:

<ag-grid-angular style="width: 500px; height: 500px;" class="ag-theme-alpine" [rowData]="rowData | async" [columnDefs]="columnDefs" > </ag-grid-angular>

The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid. However, you will see an additional HTTP request performed if you open your developer tools.

Enable Selection

Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.

Fortunately, the above task is quite simple with ag-Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties. Edit src/app.component.ts first:

import { Component, OnInit, ViewChild } from '@angular/core'; import { HttpClient } from '@angular/common/http'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { title = 'app'; columnDefs = [ {headerName: 'make', field: 'make', sortable: true, filter: true, checkboxSelection: true }, {headerName: 'model', field: 'model', sortable: true, filter: true }, {headerName: 'price', field: 'price', sortable: true, filter: true } ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://raw.githubusercontent.com/ag-grid/ag-grid/master/grid-packages/ag-grid-docs/src/sample-data/rowData.json'); } }

Next, let's enable multiple row selection, so that the user can pick many rows:

<ag-grid-angular style="width: 500px; height: 500px;" class="ag-theme-alpine" [rowData]="rowData | async" [columnDefs]="columnDefs" rowSelection="multiple" > </ag-grid-angular>
We took a bit of a shortcut here, by not binding the property value. Without [], the assignment will pass the attribute value as a string, which is fine for our purposes.

Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we are going to use the ag-Grid API - we will access it through the component instance.

<ag-grid-angular #agGrid style="width: 500px; height: 500px;" class="ag-theme-alpine" [rowData]="rowData | async" [columnDefs]="columnDefs" rowSelection="multiple" > </ag-grid-angular>

Now let's make the instance accessible in our component:

import { Component, OnInit, ViewChild } from '@angular/core'; import { HttpClient } from '@angular/common/http'; import { AgGridAngular } from 'ag-grid-angular'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { @ViewChild('agGrid') agGrid: AgGridAngular; title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true, checkboxSelection: true }, {headerName: 'Model', field: 'model', sortable: true, filter: true }, {headerName: 'Price', field: 'price', sortable: true, filter: true } ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://raw.githubusercontent.com/ag-grid/ag-grid/master/grid-packages/ag-grid-docs/src/sample-data/rowData.json'); } }

The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:

<button (click)="getSelectedRows()">Get Selected Rows</button> <ag-grid-angular #agGrid style="width: 500px; height: 500px;" class="ag-theme-alpine" [rowData]="rowData | async" [columnDefs]="columnDefs" rowSelection="multiple" > </ag-grid-angular> import { Component, OnInit, ViewChild } from '@angular/core'; import { HttpClient } from '@angular/common/http'; import { AgGridAngular } from 'ag-grid-angular'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { @ViewChild('agGrid') agGrid: AgGridAngular; title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true, checkboxSelection: true }, {headerName: 'Model', field: 'model', sortable: true, filter: true }, {headerName: 'Price', field: 'price', sortable: true, filter: true } ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://raw.githubusercontent.com/ag-grid/ag-grid/master/grid-packages/ag-grid-docs/src/sample-data/rowData.json'); } getSelectedRows() { const selectedNodes = this.agGrid.api.getSelectedNodes(); const selectedData = selectedNodes.map( node => node.data ); const selectedDataStringPresentation = selectedData.map( node => node.make + ' ' + node.model).join(', '); alert(`Selected nodes: ${selectedDataStringPresentation}`); } }

Well, we cheated a bit. Calling alert is not exactly a call to our backend. Hopefully you will forgive us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit with a real-world application logic after you are done with the tutorial.

Grouping

Grouping is a feature exclusive to ag-Grid Enterprise. You are free to trial ag-Grid Enterprise to see what you think. You only need to get in touch if you want to start using ag-Grid Enterprise in a project intended for production.

In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data.

Let's enable the enterprise features of ag-grid. Install the additional package:

npm install --save ag-grid-enterprise

Then, add the import to app.module.ts:

import { AgGridModule } from 'ag-grid-angular'; import { HttpClientModule } from '@angular/common/http'; +import 'ag-grid-enterprise';

If everything is ok, you should see a message in the console that tells you there is no enterprise license key. You can ignore the message as we are trialing. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

ag-Grid final

Now, let's enable grouping! Add an autoGroupColumnDef property and change the columnDefs to the following:

export class AppComponent implements OnInit { @ViewChild('agGrid') agGrid: AgGridAngular; title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', rowGroup: true }, {headerName: 'Price', field: 'price'} ]; autoGroupColumnDef = { headerName: 'Model', field: 'model', cellRenderer: 'agGroupCellRenderer', cellRendererParams: { checkbox: true } }; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://raw.githubusercontent.com/ag-grid/ag-grid/master/grid-packages/ag-grid-docs/src/sample-data/rowData.json'); } getSelectedRows() { const selectedNodes = this.agGrid.api.getSelectedNodes(); const selectedData = selectedNodes.map( node => node.data ); const selectedDataStringPresentation = selectedData.map( node => node.make + ' ' + node.model).join(', '); alert(`Selected nodes: ${selectedDataStringPresentation}`); } }

Add the the autoGroupColumnDef property to the template too:

class="ag-theme-alpine" +[autoGroupColumnDef]="autoGroupColumnDef"

There we go! The grid now groups the data by make, while listing the model field value when expanded. Notice that grouping works with checkboxes as well - the groupSelectsChildren property adds a group-level checkbox that selects/deselects all items in the group.

Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.

Customise the Theme Look

The last thing which we are going to do is to change the grid look and feel by modifying some of the theme's parameters.

Open style.scss and add some parameters:

@import "../node_modules/ag-grid-community/src/styles/ag-grid.scss"; @import "../node_modules/ag-grid-community/src/styles/ag-theme-alpine/sass/ag-theme-alpine-mixin.scss"; .ag-theme-alpine { @include ag-theme-alpine(( odd-row-background-color: #CFD8DC )); }

You can find a full list of theme parameters here.

If everything is configured correctly, the second row of the grid will get slightly darker. Congratulations! You now know now bend the grid look to your will - there are a few dozens more Sass variables that let you control the font family and size, border color, header background color and even the amount of spacing in the cells and columns. The full theme parameter list is available in the themes documentation section.

Summary

With this Angular grid tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid, how to access its API object, and how to change the styling of the component.

Want to know more?

Want to see some full examples of customising ag-Grid using Angular components? See this blog written by Max Koretskyi (aka Angular in Depth Wizard) Learn to customise Angular grid in less than 10 minutes.

A full working examples of ag-Grid and Angular can be found in Github, illustrating (amongst others) rich grids, filtering with angular components and master/detail.

Vue Data GridQuick Start
vue logo

Welcome to the AG Grid documentation. After reading this page you will have an overview of the key concepts of AG Grid that you will use on a daily basis.

Your First Grid

Add AG Grid to your application in these steps:

1. NPM Install

npm install ag-grid-vue3

2. Import the Grid

<template></template>

<script>
import { ref } from 'vue';
import "ag-grid-community/styles/ag-grid.css"; // Mandatory CSS required by the grid
import "ag-grid-community/styles/ag-theme-quartz.css"; // Optional Theme applied to the grid
import { AgGridVue } from "ag-grid-vue3"; // AG Grid Component

export default {
  name: "App",
  components: {
    AgGridVue, // Add AG Grid Vue3 component
  },
  setup() {},
};
</script>

3. Define Rows and Columns

setup() {
  // Row Data: The data to be displayed.
  const rowData = ref([
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
  ]);

  // Column Definitions: Defines the columns to be displayed.
  const colDefs = ref([
    { field: "make" },
    { field: "model" },
    { field: "price" },
    { field: "electric" }
  ]);

  return {
    rowData,
    colDefs,
  };
},

4. Grid Component

Rows and Columns are set as ag-grid-vue component attributes. Styling is applied through the class and style attributes.

<template>
  <!-- The AG Grid component -->
  <ag-grid-vue
    :rowData="rowData"
    :columnDefs="colDefs"
    style="height: 500px"
    class="ag-theme-quartz"
  >
  </ag-grid-vue>
</template>

5. Finished

Below is a live example of the application running. Click </> Code to see the code.

To live-edit the code, open the example in CodeSandbox or Plunker using the buttons to the lower-right.

Now that you have a basic grid running, the remainder of this page explores some of the key concepts.

Showing Data

Mapping Values

The field or valueGetter attributes map data to columns. A field maps to a field in the data. A Value Getter is a function callback that returns the cell value.

The headerName provides the title for the header. If missing the title is derived from field.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { headerName: "Make & Model", valueGetter: p => p.make + ' ' + p.model},
    { field: "price" },
];

Formatting

Format cell content using a Value Formatter.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "price", valueFormatter: p => '£' + Math.floor(p.value).toLocaleString() },
];

Cell Components

Add buttons, checkboxes or images to cells with a Cell Renderer.

// ...
  components: {
    "ag-grid-vue": AgGridVue,
    CustomButtonComponent: {
      template: `
         <button @click="buttonClicked()">Push Me!</button>
        `,
      methods: {
        buttonClicked() {
          alert("clicked");
        },
      },
    },
  },
  data: function () {
    return {
    columnDefs: [
        { field: "button", cellRenderer: CustomButtonComponent },
        // ...
    ],
  };
},
// ...

Resizing Columns

Columns are Resized by dragging the Column Header edges. Additionally assign flex values to allow columns to flex to the grid width.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", flex: 2 }, //This column will be twice as wide as the others
    { field: "model", flex: 1 },
    { field: "price", flex: 1 },
    { field: "electric", flex: 1 }
];

Example

This example demonstrates mapping and formatting values, cell components, and resizing columns.

Working with Data

By default, the row data is used to infer the Cell Data Type. The cell data type allows grid features, such as filtering and editing, to work without additional configuration.

Filtering

Column Filters are embedded into each column menu. These are enabled using the filter attribute. The filter type is inferred from the cell data type.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", filter: true },
];

There are 5 Provided Filters which can be set through this attribute. You can also create your own Custom Filter.

Floating Filters embed the Column Filter into the header for ease of access.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", filter: true, floatingFilter: true },
];

Editing

Enable Editing by setting the editable attribute to true. The cell editor is inferred from the cell data type.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    { field: "make", editable: true },
];

Set the cell editor type using the cellEditor attribute. There are 7 Provided Cell Editors which can be set through this attribute. You can also create your own Custom Editors.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: "make",
        editable: true,
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: ['Tesla', 'Ford', 'Toyota'],
        },
    },
];

Sorting

Data is Sorted by clicking the column headers. Sorting is enabled by default.

Row Selection

Row Selection is enabled using the rowSelection attribute. Use the checkboxSelection column definition attribute to render checkboxes for selection.

<ag-grid-vue
    :columnDefs="columnDefs"
    :rowSelection="rowSelection"
    /* other grid options ... */>
</ag-grid-vue>

// Column Definitions: Defines the columns to be displayed.
this.columnDefs = [
    { field: "make", checkboxSelection: true },
];
this.rowSelection = 'multiple';

Pagination

Enable Pagination by setting pagination to be true.

<ag-grid-vue
    :pagination="pagination"
    :paginationPageSize="paginationPageSize"
    :paginationPageSizeSelector="paginationPageSizeSelector"
    /* other grid options ... */>
</ag-grid-vue>

this.pagination = true;
this.paginationPageSize = 500;
this.paginationPageSizeSelector = [200, 500, 1000];

Example

This example demonstrates filtering, editing, sorting, row selection, and pagination.

Themes & Style

Themes

Grid Themes define how the grid looks (colors, font, spacing etc). The grid comes with Provided Themes such as Quartz and Alpine. To use a theme you need to 1) import the themes CSS and 2) apply the theme to the parent HTML element of the grid.

import "ag-grid-community/styles/ag-theme-quartz.css"; // import Quartz theme
// import "ag-grid-community/styles/ag-theme-alpine.css"; // import Alpine theme, not used here

const VueExample = {
  template: `
        <div style="height: 100%">
            <div style="height: 100%; box-sizing: border-box;">
                <ag-grid-vue
                // ...
                :class="themeClass"></ag-grid-vue>
            </div>
        </div>
    `,
// ...
  data: function () {
    return {
      // ...
      themeClass: "ag-theme-quartz",
    };
  },
 // ...
Quartz
AG Theme Quartz
Quartz Dark
AG Theme Quartz Dark
Alpine
AG Theme Alpine
Alpine Dark
AG Theme Alpine Dark

Customising a Theme

Customise themes using CSS variables.

.ag-theme-quartz {
    /* Changes the color of the grid text */
    --ag-foreground-color: rgb(163, 64, 64);
    /* Changes the color of the grid background */
    --ag-background-color: rgba(215, 245, 231, 0.212);
    /* Changes the background color of selected rows */
    --ag-selected-row-background-color: rgba(0, 38, 255, 0.1);
}
Customising a Theme with CSS Variables

Figma

If you are designing within Figma, you can use the AG Grid Design System to replicate the Quartz and Alpine AG Grid themes within Figma. These default themes can be extended with Figma variables to match any existing visual design or create entirely new AG Grid themes. These can then be exported and generated into new AG Grid themes.

Figma Design System with AG Grid

Cell Style

Define rules to apply styling to cells using cellClassRules. This can be used, for example, to set cell background colour based on its value.

.rag-green {
  background-color: #33cc3344;
}
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [{
    field: 'electric',
    cellClassRules: {
        // apply green to electric cars
        'rag-green': params => params.value === true,
    }
}];

Row Style

Define rules to apply styling to rows using and rowClassRules. This allows changing style (e.g. row colour) based on row values.

.rag-red {
  background-color: #cc222244;
}
<ag-grid-vue
    :rowClassRules="rowClassRules"
    /* other grid options ... */>
</ag-grid-vue>

this.rowClassRules = {
    // apply red to Ford cars
    'rag-red': params => params.data.make === 'Ford',
};

Example

This example demonstrates cell style and row style.

Next Steps

React Data GridQuick Start
react logo

Welcome to the AG Grid documentation. After reading this page you will have an overview of the key concepts of AG Grid that you will use on a daily basis.

Your First Grid

Add AG Grid to your application in these steps:

1. NPM Install

npm install ag-grid-react

2. Import the Grid

import { AgGridReact } from 'ag-grid-react'; // AG Grid Component
import "ag-grid-community/styles/ag-grid.css"; // Mandatory CSS required by the grid
import "ag-grid-community/styles/ag-theme-quartz.css"; // Optional Theme applied to the grid

3. Define Rows and Columns

const GridExample = () => {
  // Row Data: The data to be displayed.
  const [rowData, setRowData] = useState([
    { make: "Tesla", model: "Model Y", price: 64950, electric: true },
    { make: "Ford", model: "F-Series", price: 33850, electric: false },
    { make: "Toyota", model: "Corolla", price: 29600, electric: false },
  ]);
  
  // Column Definitions: Defines the columns to be displayed.
  const [colDefs, setColDefs] = useState([
    { field: "make" },
    { field: "model" },
    { field: "price" },
    { field: "electric" }
  ]);

  // ...

}

4. Grid Component

The AgGridReact component is wrapped in a parent container div. Style is applied to the parent container. Rows and Columns are set as AgGridReact component attributes.

return (
  // wrapping container with theme & size
  <div
   className="ag-theme-quartz" // applying the grid theme
   style={{ height: 500 }} // the grid will fill the size of the parent container
  >
    <AgGridReact
        rowData={rowData}
        columnDefs={colDefs}
    />
  </div>
)

5. Finished

Below is a live example of the application running. Click </> Code to see the code.

To live-edit the code, open the example in CodeSandbox or Plunker using the buttons to the lower-right.

Now that you have a basic grid running, the remainder of this page explores some of the key concepts.

Showing Data

Mapping Values

The field or valueGetter attributes map data to columns. A field maps to a field in the data. A Value Getter is a function callback that returns the cell value.

The headerName provides the title for the header. If missing the title is derived from field.

const [columnDefs, setColumnDefs] = useState([
    { headerName: "Make & Model", valueGetter: p => p.make + ' ' + p.model},
    { field: "price" },
]);

<AgGridReact columnDefs={columnDefs} />

Formatting

Format cell content using a Value Formatter.

const [columnDefs, setColumnDefs] = useState([
    { field: "price", valueFormatter: p => '£' + Math.floor(p.value).toLocaleString() },
]);

<AgGridReact columnDefs={columnDefs} />

Cell Components

Add buttons, checkboxes or images to cells with a Cell Renderer.

const CustomButtonComponent = (props) => {
    return <button onClick={() => window.alert('clicked') }>Push Me!</button>;
  };

 const [colDefs, setColDefs] = useState([
    { field: "button", cellRenderer: CustomButtonComponent },
    // ...
  ]);

Resizing Columns

Columns are Resized by dragging the Column Header edges. Additionally assign flex values to allow columns to flex to the grid width.

const [columnDefs, setColumnDefs] = useState([
    { field: "make", flex: 2 }, //This column will be twice as wide as the others
    { field: "model", flex: 1 },
    { field: "price", flex: 1 },
    { field: "electric", flex: 1 }
]);

<AgGridReact columnDefs={columnDefs} />

Example

This example demonstrates mapping and formatting values, cell components, and resizing columns.

Working with Data

By default, the row data is used to infer the Cell Data Type. The cell data type allows grid features, such as filtering and editing, to work without additional configuration.

Filtering

Column Filters are embedded into each column menu. These are enabled using the filter attribute. The filter type is inferred from the cell data type.

const [columnDefs, setColumnDefs] = useState([
    { field: "make", filter: true },
]);

<AgGridReact columnDefs={columnDefs} />

There are 5 Provided Filters which can be set through this attribute. You can also create your own Custom Filter.

Floating Filters embed the Column Filter into the header for ease of access.

const [columnDefs, setColumnDefs] = useState([
    { field: "make", filter: true, floatingFilter: true },
]);

<AgGridReact columnDefs={columnDefs} />

Editing

Enable Editing by setting the editable attribute to true. The cell editor is inferred from the cell data type.

const [columnDefs, setColumnDefs] = useState([
    { field: "make", editable: true },
]);

<AgGridReact columnDefs={columnDefs} />

Set the cell editor type using the cellEditor attribute. There are 7 Provided Cell Editors which can be set through this attribute. You can also create your own Custom Editors.

const [columnDefs, setColumnDefs] = useState([
    {
        field: "make",
        editable: true,
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: ['Tesla', 'Ford', 'Toyota'],
        },
    },
]);

<AgGridReact columnDefs={columnDefs} />

Sorting

Data is Sorted by clicking the column headers. Sorting is enabled by default.

Row Selection

Row Selection is enabled using the rowSelection attribute. Use the checkboxSelection column definition attribute to render checkboxes for selection.

// Column Definitions: Defines the columns to be displayed.
const [columnDefs, setColumnDefs] = useState([
    { field: "make", checkboxSelection: true },
]);
const rowSelection = 'multiple';

<AgGridReact
    columnDefs={columnDefs}
    rowSelection={rowSelection}
/>

Pagination

Enable Pagination by setting pagination to be true.

const pagination = true;
const paginationPageSize = 500;
const paginationPageSizeSelector = [200, 500, 1000];

<AgGridReact
    pagination={pagination}
    paginationPageSize={paginationPageSize}
    paginationPageSizeSelector={paginationPageSizeSelector}
/>

Example

This example demonstrates filtering, editing, sorting, row selection, and pagination.

Themes & Style

Themes

Grid Themes define how the grid looks (colors, font, spacing etc). The grid comes with Provided Themes such as Quartz and Alpine. To use a theme you need to 1) import the themes CSS and 2) apply the theme to the parent HTML element of the grid.

import "ag-grid-community/styles/ag-theme-quartz.css"; // import Quartz theme
// import "ag-grid-community/styles/ag-theme-alpine.css"; // import Alpine theme, not used here
 ...
return (
  <div class="ag-theme-quartz"> // set Quartz Theme on parent div
    <AgGridReact rowData={...} columnDefs={...} />
  </div>
)
Quartz
AG Theme Quartz
Quartz Dark
AG Theme Quartz Dark
Alpine
AG Theme Alpine
Alpine Dark
AG Theme Alpine Dark

Customising a Theme

Customise themes using CSS variables.

.ag-theme-quartz {
    /* Changes the color of the grid text */
    --ag-foreground-color: rgb(163, 64, 64);
    /* Changes the color of the grid background */
    --ag-background-color: rgba(215, 245, 231, 0.212);
    /* Changes the background color of selected rows */
    --ag-selected-row-background-color: rgba(0, 38, 255, 0.1);
}
Customising a Theme with CSS Variables

Figma

If you are designing within Figma, you can use the AG Grid Design System to replicate the Quartz and Alpine AG Grid themes within Figma. These default themes can be extended with Figma variables to match any existing visual design or create entirely new AG Grid themes. These can then be exported and generated into new AG Grid themes.

Figma Design System with AG Grid

Cell Style

Define rules to apply styling to cells using cellClassRules. This can be used, for example, to set cell background colour based on its value.

.rag-green {
  background-color: #33cc3344;
}
const [columnDefs, setColumnDefs] = useState([{
    field: 'electric',
    cellClassRules: {
        // apply green to electric cars
        'rag-green': params => params.value === true,
    }
}]);

<AgGridReact columnDefs={columnDefs} />

Row Style

Define rules to apply styling to rows using and rowClassRules. This allows changing style (e.g. row colour) based on row values.

.rag-red {
  background-color: #cc222244;
}
const rowClassRules = {
    // apply red to Ford cars
    'rag-red': params => params.data.make === 'Ford',
};

<AgGridReact rowClassRules={rowClassRules} />

Example

This example demonstrates cell style and row style.

Next Steps